
-- thing that lets you drift
-- its legit just a drift
-- -Pacola

local function P_DoSpinDashDust(player) -- haha i translated P_DoSpinDashDust to lua
	local particle = nil
	local prandom = {}
	for i = 0, (leveltime%7)/2 do // 1, 2, 3 or 4 particles
		particle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)

		if (player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		elseif (player.powers[pw_shield] == SH_ELEMENTAL)
			particle.state = S_SPINDUST_FIRE1
		end
		
		particle.target = player.mo
		particle.destscale = (2*player.mo.scale)/3
		P_SetScale(particle, particle.destscale)
		if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
			particle.z = player.mo.z + player.mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, player.dashspeed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + (prandom[1]*ANG1),
				-FixedMul(player.dashspeed/12 + FRACUNIT + prandom[2], player.mo.scale))
		P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
	end
end

addHook("SpinSpecial", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "saosonic"
	or not P_IsObjectOnGround(p.mo) return end
	
	if p.slinkdashin return true end
	
	if p.speed < p.normalspeed return end
	
	S_StartSound(p.mo, sfx_spndsh)
	p.slinkdashin = true
	p.slinkdashinolddash = {
		p.runtime,
		p.normalspeed,
		p.fakenormalspeed,
		p.jumpfactor,
		p.speed
	}
	p.pflags = $ & ~PF_SPINNING
	return true
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "saosonic" return end
	
	if p.slinkdashin == nil
		p.slinkdashin = false
	end
	
	if p.slinkdashin
		if P_PlayerInPain(p)
		or p.playerstate == PST_DEAD
			p.slinkdashin = false
			return
		end
		
		if not (p.cmd.buttons & BT_SPIN)
			S_StartSound(p.mo, sfx_zoom)
			p.mo.state = S_PLAY_RUN
			local t = p.slinkdashinolddash
			p.runtime = t[1]
			p.normalspeed = t[2]
			p.fakenormalspeed = t[3]
			p.jumpfactor = t[4]
			P_InstaThrust(p.mo, p.mo.angle, t[5])
			P_MovePlayer(p)
			p.slinkdashin = false
			p.slinkdashinolddash = nil
			return
		end
		if p.mo.state ~= S_PLAY_SPINDASH
			p.mo.state = S_PLAY_SPINDASH
		end
		p.pflags = $1|PF_FULLSTASIS
		p.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM
		p.drawangle = p.mo.angle
		P_DoSpinDashDust(p)
	end
end)